addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and player.pizzablast
	and player.pizzablast.other.pbparts ~= 1
	and player.pizzablast.other.pbparts ~= 3
		local bodyslam = player.pizzablast.moveset.bodyslam
		local buttons = player.pizzablast.moveset.buttons
		local pb = player.pizzablast
		if buttons.c1 == 1
		and not pb.moveset.mach.active
		and not P_IsObjectOnGround(player.mo)
		and not pb.moveset.grab.active
		and not pb.moveset.slide.active
		and not pb.moveset.superjump.active
		and not pb.moveset.superjump.build.active
		and not pb.moveset.superjump.cactive
		and not pb.moveset.taunt.active
		and not pb.moveset.taunt.timer
		and not pb.moveset.roll.active
		and not pb.moveset.bash.active
		and not pb.moveset.dive.active
		and not pb.moveset.bodyslam.active
		and not pb.moveset.divebomb.active
		and not pb.moveset.divebomb.cactive
		and not pb.moveset.bodyslam.cactive
		and not pb.moveset.redirect.active
		and not pb.moveset.wallrun.active
		and not P_PlayerInPain(player)
		and player.mo.state ~= S_PLAY_PAIN
		and player.playerstate == PST_LIVE
		and not player.powers[pw_carry]
			bodyslam.active = true
			S_StartSound(player.mo, sfx_bs)
			P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
		end
		if bodyslam.active
			if player.mo.state == S_PLAY_PAIN
			or P_PlayerInPain(player)
			or player.playerstate ~= PST_LIVE
			or (player.mo.eflags & MFE_SPRUNG)
			or (player.mo.eflags & MFE_GOOWATER)
			or player.powers[pw_carry]
				bodyslam.active = false
				player.powers[pw_strong] = $ & ~(STR_FLOOR|STR_SPIKE|STR_SPRING)
				S_StopSoundByID(player.mo, sfx_bs)
				S_StopSoundByID(player.mo, sfx_bl)
				return
			end
			P_SetObjectMomZ(player.mo, -FRACUNIT/2, true)
			player.mo.state = S_PLAY_ROLL
			player.powers[pw_strong] = $|STR_FLOOR|STR_SPIKE|STR_SPRING
			if not S_SoundPlaying(player.mo, sfx_bs)
			and not S_SoundPlaying(player.mo, sfx_bl)
				S_StartSound(player.mo, sfx_bl)
			end
			if player.mo.momz <= -20*FRACUNIT
			and leveltime%2 == 0
				local mobj = P_SpawnGhostMobj(player.mo)
				mobj.colorized = true
				mobj.frame = TR_TRANS10|player.mo.frame|FF_FULLBRIGHT
				mobj.fuse = 999
				mobj.tics = 5
				if leveltime%4 ~= 0
					mobj.color = SKINCOLOR_GREEN
				else
					mobj.color = SKINCOLOR_RED
				end
			end
			if not P_IsObjectOnGround(player.mo)
			and not (player.mo.eflags & MFE_JUSTHITFLOOR)
				bodyslam.momz = player.mo.momz
			elseif (P_IsObjectOnGround(player.mo)
			or (player.mo.eflags & MFE_JUSTHITFLOOR))
				S_StartSound(player.mo, sfx_bd)
				if S_SoundPlaying(player.mo, sfx_bl)
					S_StopSoundByID(player.mo, sfx_bl)
				end
				if S_SoundPlaying(player.mo, sfx_bs)
					S_StopSoundByID(player.mo, sfx_bs)
				end
				pb.moveset.bodyslam.active = false
				player.powers[pw_strong] = $ & ~(STR_FLOOR|STR_SPIKE|STR_SPRING)
				if not player.mo.standingslope
					player.mo.spriteyscale = (FU/3)
					player.mo.spritexscale = (player.mo.spriteyscale*8)
					pb.moveset.bodyslam.timer = 15
					if bodyslam.momz <= -20*FRACUNIT
						PB_LaunchEnemies(player)
					end
				end
			end
		end
		if bodyslam.timer
			if player.mo.state == S_PLAY_PAIN
			or P_PlayerInPain(player)
			or player.playerstate ~= PST_LIVE
				bodyslam.timer = 0
				return
			end
			bodyslam.cactive = true
			bodyslam.timer = $ - 1
			P_InstaThrust(player.mo, player.mo.angle, 0*FRACUNIT)
			player.mo.state = S_PLAY_ROLL
			player.powers[pw_strong] = $ & ~(STR_FLOOR|STR_SPIKE|STR_SPRING)
			player.pflags = $|PF_FULLSTASIS
		elseif bodyslam.timer <= 0
		and bodyslam.cactive == true
			if not (player.mo.state == S_PLAY_PAIN
			or P_PlayerInPain(player)
			or player.playerstate ~= PST_LIVE)
				P_InstaThrust(player.mo, player.mo.angle, 0*FRACUNIT)
				player.mo.state = S_PLAY_STND
			end
			player.mo.spriteyscale = FRACUNIT
			player.mo.spritexscale = FRACUNIT
			bodyslam.cactive = false
		end
	end
end)

addHook("PlayerCanDamage", function(player)
	if player.pizzablast.moveset.bodyslam.active
		return true
	end
end)