addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and player.pizzablast
		local pb = player.pizzablast
		local combo = pb.combo
		if combo.timer 
		and not (player.pflags & PF_FINISHED) 
		and (not player.powers[pw_carry]
		or player.powers[pw_carry]
		and (player.powers[pw_carry] & CR_PLAYER))
		and mapheaderinfo[gamemap].bonustype < 1
			combo.timer = $ - 1
			combo.active = true
		end
		if combo.timer <= 0
		and combo.active
			combo.active = false
			if not (player.exiting 
			or (player.pflags & PF_FINISHED))
				combo.canp = false
			end
			P_AddPlayerScore(player, combo.amount*500)
			combo.amount = 0
			S_StartSound(player.mo, 163, player)
			combo.congrats = false
		end
		if not (player.exiting 
		or (player.pflags & PF_FINISHED))
			if not pb.other.hardmode
				if combo.canp
					if pb.other.Lap2Active
						combo.isp = true
					end
				else
					combo.isp = false
				end
			else
				combo.isp = true
			end
		end
		if combo.timer > 400
			combo.timer = 400
		end
		if player.exiting 
		or (player.pflags & PF_FINISHED)
		and pb.other.hardmode == true
			combo.canp = true
		end
		if player.exiting 
		or (player.pflags & PF_FINISHED)
			combo.timer = 0
		end
		if combo.timer < 0
			combo.timer = 0
		end
		if pb.other.hardmode 
		and combo.timer 
		and not player.exiting 
		and not (player.pflags & PF_FINISHED)
		and not combo.canp
		and (player.playerstate == PST_LIVE)
			player.lives = 0
			P_KillMobj(player.mo, player.mo, player.mo)
			player.lives = 0
		end
	end
end)

addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if source and source.valid 
	and source.player and source.player.valid 
	and not (source.player.pflags & PF_FINISHED)
	and (target.flags & MF_ENEMY or target.flags & MF_MONITOR)
		source.player.pizzablast.combo.timer = 400
		source.player.pizzablast.combo.amount = $ + 1
		if target.type == MT_RING_BOX
			source.player.score = $ + 1500
		end
	end
end)

addHook("TouchSpecial", function(special, toucher)
	if toucher and toucher.valid
	and not (toucher.player.pflags & PF_FINISHED)
		if P_CanPickupItem(toucher.player, special)
			toucher.player.score = $ + 150
		end
		if toucher.player.pizzablast.combo.timer
			toucher.player.pizzablast.combo.timer = $ + 20
			if toucher.player.pizzablast.other.hardmode
				toucher.player.pizzablast.combo.timer = $ + 40
			end
		end
	end
end, MT_RING)

addHook("TouchSpecial", function(special, toucher)
	if toucher.player.starpostnum < special.health 
	and toucher.player.pizzablast.combo.timer 
	and not (toucher.player.pflags & PF_FINISHED)
		toucher.player.pizzablast.combo.timer = 400
		toucher.player.pizzablast.combo.amount = $ + 1
		toucher.player.score = toucher.player.score + 1000
	end
end, MT_STARPOST)

addHook("MobjDamage", function(target)
	if target and target.valid
	and target.player and target.player.valid
	and not (target.player.pflags & PF_FINISHED)
	and target.player.pizzablast.combo.timer
		target.player.pizzablast.combo.timer = $ - 90
	end
end, MT_PLAYER)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.mo and player.mo.valid
		and player.pizzablast
			local pb = player.pizzablast
			if multiplayer
				if pb.combo.congrats == false
				and ((player.pflags & PF_FINISHED)
				or player.exiting)
				and player.playerstate == PST_LIVE
				and pb.combo.timer <= 0
				and not pb.combo.active
				and S_SoundPlaying(player.mo, 163)
					if player.score < 500
						chatprint(player.name+" just got a D! You truly are a failure of highest degree!")
						pb.combo.congrats = true
					elseif player.score >= 500 and player.score < 15000
						chatprint(player.name+" just got a C! Try putting effort in next time!")
						pb.combo.congrats = true
					elseif player.score >= 15000 and player.score < 25000
						chatprint(player.name+" just got a B! I'm sure they can do better than this!")
						pb.combo.congrats = true
					elseif player.score >= 25000 and player.score < 30000
						chatprint(player.name+" just got a A! They're doing real good!")
						pb.combo.congrats = true
					elseif player.score >= 30000 and player.score < 35000
						chatprint(player.name+" just got a S! They truly showed themselves to be a star!")
						pb.combo.congrats = true
					elseif player.score >= 35000
						if not pb.combo.isp
							chatprint(player.name+" just got a S! They truly showed themselves to be a star!")
							pb.combo.congrats = true
						else
							if not pb.other.hardmode
								chatprint(player.name+" just got a P! A perfectionist in all possible ways!")
								pb.combo.congrats = true
							elseif pb.other.hardmode
								chatprint(player.name+" just beat Hard Mode in " + (string.format( '%d:%02d', G_TicsToMinutes(player.realtime), G_TicsToSeconds(player.realtime) )))
								pb.combo.congrats = true
							end
						end
					end
				end
			else
				if pb.combo.congrats == false
				and ((player.pflags & PF_FINISHED)
				or player.exiting)
					if player.score < 500
						print(player.name+" just got a D! You truly are a failure of highest degree!")
						pb.combo.congrats = true
					elseif player.score >= 500 and player.score < 15000
						print(player.name+" just got a C! Try putting effort in next time!")
						pb.combo.congrats = true
					elseif player.score >= 15000 and player.score < 25000
						print(player.name+" just got a B! I'm sure they can do better than this!")
						pb.combo.congrats = true
					elseif player.score >= 25000 and player.score < 30000
						print(player.name+" just got a A! They're doing real good!")
						pb.combo.congrats = true
					elseif player.score >= 30000 and player.score < 35000
						print(player.name+" just got a S! They truly showed themselves to be a star!")
						pb.combo.congrats = true
					elseif player.score >= 35000
						if not pb.combo.isp
							print(player.name+" just got a S! They truly showed themselves to be a star!")
							pb.combo.congrats = true
						else
							if not pb.other.hardmode
								print(player.name+" just got a P! A perfectionist in all possible ways!")
								pb.combo.congrats = true
							elseif pb.other.hardmode
								print(player.name+" just beat Hard Mode in " + (string.format( '%d:%02d', G_TicsToMinutes(player.realtime), G_TicsToSeconds(player.realtime) )))
								pb.combo.congrats = true
							end
						end
					end
				end
			end
		end
	end
end)
			

-- The HUD code, developed by MARIOMARIO13531.
-- Some of the code is from boss hud mod made by Inuyasha.
--Lol I took this from Boost, well, the beginning part
local function comb(v, player)
	if player.mo and player.mo.valid
	and player.pizzablast
		local pb = player.pizzablast
		local combo = pb.combo
		if (maptol & TOL_NIGHTS) or combo.timer == nil then -- Prevents the code from running in a Nights special stage
			return
		end 
		
			local comindanim = ((leveltime/2) % 8) + 1
			local p_comb = v.cachePatch("COMBR") --this junk is mine
			local p_ind = v.cachePatch( 'COMIND' .. comindanim )
			local p_0 = v.cachePatch("NUMB0")
			local p_1 = v.cachePatch("NUMB1")
			local p_2 = v.cachePatch("NUMB2")
			local p_3 = v.cachePatch("NUMB3")
			local p_4 = v.cachePatch("NUMB4")
			local p_5 = v.cachePatch("NUMB5")
			local p_6 = v.cachePatch("NUMB6")
			local p_7 = v.cachePatch("NUMB7")
			local p_8 = v.cachePatch("NUMB8")
			local p_9 = v.cachePatch("NUMB9")
			local posx = (combo.timer/6)

		if player.mo.valid and combo.timer
			v.drawScaled(posx*FRACUNIT, 15*FRACUNIT, FRACUNIT/2, p_ind, V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
			v.drawScaled(FRACUNIT, FRACUNIT, FRACUNIT/2, p_comb, V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
			DrawInFont(true, false, 2, v, player.pizzablast.combo.amount, 65, 45, 'PBNUM', V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOTOP, 10)
		end
	end
end
hud.add(comb, "game")

local function ranks(v, player)
	if player.mo and player.mo.valid
	and player.pizzablast
		if (maptol & TOL_NIGHTS) then -- Prevents the code from running in a Nights special stage
			return
		end 
			local p_rand = v.cachePatch("RANKD") --this junk is mine
			local p_ranc = v.cachePatch("RANKC")
			local p_ranb = v.cachePatch("RANKB")
			local p_rana = v.cachePatch("RANKA")
			local p_rans = v.cachePatch("RANPEE")
			local p_ranp = v.cachePatch("RANKP")
				
		if player.mo.valid and player.score < 500
			v.drawScaled(100*FRACUNIT, 25*FRACUNIT, FRACUNIT/2, p_rand, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		end
		if player.mo.valid and player.score >= 500 and player.score < 15000
			v.drawScaled(100*FRACUNIT, 25*FRACUNIT, FRACUNIT/2, p_ranc, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		end
		if player.mo.valid and player.score >= 15000 and player.score < 25000
			v.drawScaled(100*FRACUNIT, 25*FRACUNIT, FRACUNIT/2, p_ranb, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		end
		if player.mo.valid and player.score >= 25000 and player.score < 30000
			v.drawScaled(100*FRACUNIT, 25*FRACUNIT, FRACUNIT/2, p_rana, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		end
		if player.mo.valid and player.score >= 30000
			v.drawScaled(100*FRACUNIT, 25*FRACUNIT, FRACUNIT/2, p_rans, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		end
		if player.mo.valid and player.score >= 35000 and player.pizzablast.combo.isp
			v.drawScaled(100*FRACUNIT, 25*FRACUNIT, FRACUNIT/2, p_ranp, V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		end
	end
end
hud.add(ranks, "game")