addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and player.pizzablast
	and player.pizzablast.other.pbparts ~= 1
	and player.pizzablast.other.pbparts ~= 3
		local divebomb = player.pizzablast.moveset.divebomb
		local buttons = player.pizzablast.moveset.buttons
		local pb = player.pizzablast
		if buttons.jump == 1
		and pb.moveset.dive.active
		and not pb.moveset.divebomb.active
		and not pb.moveset.divebomb.cactive
		and not pb.moveset.bodyslam.active
		and not pb.moveset.bodyslam.cactive
		and not pb.moveset.redirect.active
		and not pb.moveset.wallrun.active
		and not P_IsObjectOnGround(player.mo)
		and not P_PlayerInPain(player)
		and player.mo.state ~= S_PLAY_PAIN
		and player.playerstate == PST_LIVE
		and not player.powers[pw_carry]
			pb.moveset.dive.active = false
			divebomb.active = true
			divebomb.angle = player.drawangle
			S_StartSound(player.mo, sfx_bs)
			P_SetObjectMomZ(player.mo, 20*FRACUNIT, false)
		end
		if divebomb.active
			if player.mo.state == S_PLAY_PAIN
			or P_PlayerInPain(player)
			or player.playerstate ~= PST_LIVE
			or (player.mo.eflags & MFE_SPRUNG)
			or (player.mo.eflags & MFE_GOOWATER)
			or player.powers[pw_carry]
				divebomb.active = false
				player.powers[pw_strong] = $ & ~(STR_FLOOR|STR_SPIKE|STR_SPRING)
				S_StopSoundByID(player.mo, sfx_bl)
				S_StopSoundByID(player.mo, sfx_bs)
				return
			end
			P_SetObjectMomZ(player.mo, -FRACUNIT, true)
			if player.mo.momz > 0
				player.mo.state = S_PLAY_SPRING
			else
				player.mo.state = S_PLAY_FALL
			end
			player.drawangle = divebomb.angle
			divebomb.angle = $ + ANGLE_22h
			player.powers[pw_strong] = $|STR_FLOOR|STR_SPIKE|STR_SPRING
			if not S_SoundPlaying(player.mo, sfx_bs)
			and not S_SoundPlaying(player.mo, sfx_bl)
				S_StartSound(player.mo, sfx_bl)
			end
			if player.mo.momz <= -20*FRACUNIT
			and leveltime%2 == 0
				local mobj = P_SpawnGhostMobj(player.mo)
				mobj.colorized = true
				mobj.frame = TR_TRANS10|player.mo.frame|FF_FULLBRIGHT
				mobj.fuse = 999
				mobj.tics = 5
				if leveltime%4 ~= 0
					mobj.color = SKINCOLOR_GREEN
				else
					mobj.color = SKINCOLOR_RED
				end
			end
			if not P_IsObjectOnGround(player.mo)
			and not (player.mo.eflags & MFE_JUSTHITFLOOR)
				divebomb.momz = player.mo.momz
			elseif (P_IsObjectOnGround(player.mo)
			or (player.mo.eflags & MFE_JUSTHITFLOOR))
				S_StartSound(player.mo, sfx_bd)
				if S_SoundPlaying(player.mo, sfx_bl)
					S_StopSoundByID(player.mo, sfx_bl)
				end
				if S_SoundPlaying(player.mo, sfx_bs)
					S_StopSoundByID(player.mo, sfx_bs)
				end
				divebomb.active = false
				player.powers[pw_strong] = $ & ~(STR_FLOOR|STR_SPIKE|STR_SPRING)
				if not player.mo.standingslope
					player.mo.spriteyscale = (FU/3)
					player.mo.spritexscale = (player.mo.spriteyscale*8)
					divebomb.timer = 15
					if divebomb.momz <= -20*FRACUNIT
						PB_LaunchEnemies(player)
					end
				end
			end
		end
		if divebomb.timer
			if player.mo.state == S_PLAY_PAIN
			or P_PlayerInPain(player)
				divebomb.timer = 0
				return
			end
			divebomb.cactive = true
			divebomb.timer = $ - 1
			P_InstaThrust(player.mo, player.mo.angle, 0*FRACUNIT)
			player.mo.state = S_PLAY_STND
			player.powers[pw_strong] = $ & ~(STR_FLOOR|STR_SPIKE|STR_SPRING)
			player.pflags = $|PF_JUMPSTASIS
		elseif divebomb.timer <= 0
		and divebomb.cactive == true
			if not (player.mo.state == S_PLAY_PAIN
			or P_PlayerInPain(player)
			or player.playerstate ~= PST_LIVE)
				P_InstaThrust(player.mo, player.mo.angle, 0*FRACUNIT)
				player.mo.state = S_PLAY_STND
			end
			player.mo.spriteyscale = FRACUNIT
			player.mo.spritexscale = FRACUNIT
			divebomb.cactive = false
		end
	end
end)

addHook("PlayerCanDamage", function(player)
	if player.pizzablast.moveset.divebomb.active
		return true
	end
end)