addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and player.pizzablast
	and player.pizzablast.other.pbparts ~= 1
	and player.pizzablast.other.pbparts ~= 3
		local pb = player.pizzablast
		local grab = pb.moveset.grab
		local buttons = pb.moveset.buttons
		if buttons.fire == 1
		and not grab.active
		and not grab.holding
		and not pb.moveset.slide.active
		and not pb.moveset.superjump.active
		and not pb.moveset.superjump.build.active
		and not pb.moveset.superjump.cactive
		and not P_PlayerInPain(player)
		and player.playerstate == PST_LIVE
		and not player.powers[pw_carry]
		and not pb.moveset.taunt.active
		and not pb.moveset.taunt.timer
		and not pb.moveset.bash.active
		and not pb.moveset.roll.active
		and not pb.moveset.dive.active
		and not pb.moveset.bodyslam.active
		and not pb.moveset.divebomb.active
		and not pb.moveset.divebomb.cactive
		and not pb.moveset.bodyslam.cactive
		and not pb.moveset.redirect.active
		and not pb.moveset.wallrun.active
		and not P_PlayerInPain(player)
		and player.mo.state ~= S_PLAY_PAIN
		and player.playerstate == PST_LIVE
		and not player.powers[pw_carry]
			grab.active = true
			grab.timer = 30
			S_StartSound(player.mo, sfx_grab)
			if not P_IsObjectOnGround(player.mo)
				P_InstaThrust(player.mo, player.mo.angle, player.speed)
			end
		end
		if grab.timer > 0
			if player.mo.state == S_PLAY_PAIN
			or P_PlayerInPain(player)
			or player.playerstate ~= PST_LIVE
			or player.powers[pw_carry]
				grab.timer = 0
			end
			if P_IsObjectOnGround(player.mo)
				grab.timer = $ - 1
			end
			grab.active = true
			if (player.mo.eflags & MFE_JUSTHITFLOOR)
				grab.timer = 0
				return
			end
			if P_IsObjectOnGround(player.mo)
			and not (player.mo.eflags & MFE_JUSTHITFLOOR)
				P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
			end
			if not P_IsObjectOnGround(player.mo)
			and player.speed < 15*FRACUNIT
				P_InstaThrust(player.mo, player.mo.angle, 15*FRACUNIT)
			end
			player.mo.state = S_PLAY_ROLL
			if leveltime%2 == 0
				local mobj = P_SpawnGhostMobj(player.mo)
				mobj.colorized = true
				mobj.frame = TR_TRANS10|player.mo.frame|FF_FULLBRIGHT
				mobj.fuse = 999
				mobj.tics = 5
				if leveltime%4 ~= 0
					mobj.color = SKINCOLOR_GREEN
				else
					mobj.color = SKINCOLOR_RED
				end
			end
		else
			if grab.active
				if player.mo.state ~= S_PLAY_PAIN
				and not P_PlayerInPain(player)
				and player.playerstate == PST_LIVE
					if P_IsObjectOnGround(player.mo)
						P_InstaThrust(player.mo, player.mo.angle, 30*FRACUNIT)
					end
					player.mo.state = S_PLAY_RUN
					pb.moveset.mach.active = true
				end
			end
			grab.active = false
		end
		if grab.holding
			if grab.mobj and grab.mobj.valid
				local mobj = grab.mobj
				if pb.moveset.bodyslam.cactive
					P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_BANG)
					P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_EXPLODE)
					S_StartSound(player.mo, sfx_pop, player)
					player.pizzablast.combo.timer = 400
					player.pizzablast.combo.amount = $ + 1
					if mobj.type == MT_RING_BOX
						player.score = $ + 1500
					end
					P_RemoveMobj(mobj)
				elseif not pb.moveset.bodyslam.active
					P_MoveOrigin(mobj, player.mo.x, player.mo.y, player.mo.z + (player.mo.height + player.mo.height/2))
					mobj.momz = 0
					mobj.flags = $|MF_NOCLIPTHING
					if buttons.c1 == 1
					and P_IsObjectOnGround(player.mo)
						local x,y = cos(player.drawangle),sin(player.drawangle)
						P_MoveOrigin(mobj, player.mo.x + (60*x), player.mo.y + (60*y), player.mo.z)
						mobj.momz = 0
						mobj.angle = player.drawangle - ANGLE_180
						table.insert(grab.hit, mobj)
						mobj.true_sprite = mobj.sprite
						mobj.true_flags = mobj.flags
						mobj.flags = $ & ~(MF_NOGRAVITY | MF_FLOAT | MF_NOCLIPHEIGHT | MF_NOCLIPTHING)
						mobj.state = S_KNOCKED
						grab.holding = false
						return
					end
					if buttons.fire == 1
						P_InstaThrust(mobj, player.drawangle, 50*FRACUNIT)
						P_SetObjectMomZ(mobj, 10*FRACUNIT, false)
						table.insert(grab.hit, mobj)
						grab.holding = false
						grab.mobj = nil
						mobj.true_sprite = mobj.sprite
						mobj.true_flags = mobj.flags
						mobj.state = S_KNOCKED
						player.pizzablast.combo.timer = 400
						player.pizzablast.combo.amount = $ + 1
						if mobj.type == MT_RING_BOX
							player.score = $ + 1500
						end
						mobj.flags = $|MF_NOCLIPTHING
						mobj.gonnadie = true
						return
					end
				elseif pb.moveset.bodyslam.active
					local x,y = cos(player.drawangle),sin(player.drawangle)
					P_MoveOrigin(mobj, player.mo.x + (30*x), player.mo.y + (30*y), player.mo.z)
					mobj.flags = $|MF_NOCLIPTHING
					mobj.momz = 0
					player.drawangle = grab.angle
					grab.angle = $ + ANGLE_22h
				end
			else
				grab.holding = false
			end
		end
		for k, mobj in ipairs(grab.hit)
			if mobj == true or not mobj.valid continue end
			if mobj and mobj.valid
				if mobj.newangle == nil
					mobj.newangle = mobj.angle
				end
				if mobj.boomtime == nil
					mobj.boomtime = 0*TICRATE
				end
				if mobj.boomtime > 0*TICRATE
					mobj.boomtime = mobj.boomtime - 4
				end
				if mobj.boomtime <= 0
				and mobj.gonnadie
					P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_BANG)
					mobj.boomtime = 1*TICRATE
				end
				if mobj.gonnadie
					P_SpawnMobjFromMobj(mobj, 0, 0, mobj.height/2, MT_SPINDUST)
					mobj.angle = mobj.newangle
					mobj.newangle = $ + ANG20
					mobj.flags = $ & ~(MF_NOGRAVITY | MF_FLOAT | MF_NOCLIPHEIGHT | MF_NOCLIPTHING)
					mobj.flags = $|MF_NOCLIPTHING
					mobj.state = S_KNOCKED
				end
				if not P_LookForPlayers(mobj, 512*FRACUNIT, true)
				and not mobj.gonnadie
					mobj.flags = mobj.true_flags
					mobj.state = mobj.info.spawnstate
					grab.hit[k] = true
				end
			end
		end
	end
end)

addHook("MobjMoveBlocked", function(mobj)
	for player in players.iterate()
		if player.mo and player.mo.valid
		and player.pizzablast
			local grab = player.pizzablast.moveset.grab
			local pb = player.pizzablast
			for k, mobj in ipairs(grab.hit) do
				if mobj == true or not mobj.valid continue end
				if mobj.gonnadie == true
					mobj.gonnadie = false
					P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_BANG)
					P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_EXPLODE)
					S_StartSound(player.mo, sfx_pop, player)
					P_RemoveMobj(mobj)
					grab.hit[k] = true
				end
			end
		end
	end
end)

addHook("ShouldDamage", function(target)
	for player in players.iterate()
		if player.mo and player.mo.valid
		and player.pizzablast
		and target and target.valid
			local grab = player.pizzablast.moveset.grab
			local pb = player.pizzablast
			for k, mobj in ipairs(grab.hit) do
				if mobj == true or not mobj.valid continue end
				if mobj.gonnadie == true
					return false
				end
			end
		end
	end
end)

addHook("MobjDamage", function(target, inflictor)
	if inflictor and inflictor.valid
	and target and target.valid
	and inflictor.player
	and (target.flags & MF_BOSS)
	and inflictor.player.pizzablast
	and inflictor.player.pizzablast.moveset.grab.active
	and inflictor.player.pizzablast.other.pbparts ~= 1
	and inflictor.player.pizzablast.other.pbparts ~= 3
	and target.z <= inflictor.z + inflictor.height
	and target.z + target.height >= inflictor.z
		inflictor.player.pizzablast.moveset.grab.timer = 0
	end
end)

addHook("MobjCollide", function(mobj, mo)
	if mobj and mobj.valid
	and mo and mo.valid
	and mobj.player
	and ((mo.flags & MF_ENEMY)
	or (mo.flags & MF_MONITOR))
	and mo.health == 1
	and mobj.player.pizzablast
	and mobj.player.pizzablast.moveset.grab.active
	and mobj.player.pizzablast.other.pbparts ~= 1
	and mobj.player.pizzablast.other.pbparts ~= 3
	and mo.z <= mobj.z + mobj.height
	and mo.z + mo.height >= mobj.z
		local player = mobj.player
		local pb = player.pizzablast
		local grab = pb.moveset.grab
		grab.timer = 0
		grab.mobj = mo
		grab.holding = true
	end
end)

addHook("ShouldDamage", function(target, inflictor, source)
	if target and target.valid
	and source and source.valid
	and target.player
	and target.player.pizzablast
	and ((target.player.pizzablast.moveset.grab.holding
	and source == target.player.pizzablast.moveset.grab.mobj)
	or (target.player.pizzablast.moveset.grab.active
	and ((source.flags & MF_ENEMY)
	or (source.flags & MF_MONITOR))))
		return false
	end
end)

addHook("ShouldDamage", function(target, inflictor, source)
	if target and target.valid
	and source and source.valid
	and source.player
	and source.player.pizzablast
	and ((source.player.pizzablast.moveset.grab.holding
	and target == source.player.pizzablast.moveset.grab.mobj)
	or (source.player.pizzablast.moveset.grab.active
	and ((target.flags & MF_ENEMY)
	or (target.flags & MF_MONITOR))))
		return false
	end
end)