addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and player.pizzablast
	and player.pizzablast.other.pbparts ~= 1
	and player.pizzablast.other.pbparts ~= 3
		local mach = player.pizzablast.moveset.mach
		local buttons = player.pizzablast.moveset.buttons
		local pb = player.pizzablast
		if buttons.spin
		and not pb.moveset.grab.active
		and not pb.moveset.grab.holding
		and not pb.moveset.slide.active
		and not pb.moveset.superjump.active
		and not pb.moveset.superjump.build.active
		and not pb.moveset.superjump.cactive
		and not pb.moveset.taunt.active
		and not pb.moveset.taunt.timer
		and not pb.moveset.roll.active
		and not pb.moveset.bash.active
		and not pb.moveset.dive.active
		and not pb.moveset.bodyslam.active
		and not pb.moveset.divebomb.active
		and not pb.moveset.divebomb.cactive
		and not pb.moveset.bodyslam.cactive
		and not pb.moveset.redirect.active
		and not P_PlayerInPain(player)
		and player.mo.state ~= S_PLAY_PAIN
		and player.playerstate == PST_LIVE
		and (player.cmd.forwardmove or player.cmd.sidemove)
		and not player.powers[pw_carry]
			mach.active = true
		else
			if mach.active
				player.powers[pw_strong] = $ & ~(STR_WALL|STR_SPIKE)
			end
			mach.active = false
		end
		if mach.active
			if mach.type > 2
				player.powers[pw_strong] = $|STR_WALL|STR_SPIKE
			else
				player.powers[pw_strong] = $ & ~(STR_WALL|STR_SPIKE)
			end
			if (player.cmd.forwardmove or player.cmd.sidemove)
				if player.speed < skins[player.mo.skin].runspeed
					mach.type = 1
				elseif player.speed >= skins[player.mo.skin].runspeed
				and player.speed < 40*FRACUNIT
					mach.type = 2
				elseif player.speed >= 40*FRACUNIT
				and player.speed < 60*FRACUNIT
					mach.type = 3
				elseif player.speed >= 60*FRACUNIT
					mach.type = 4
				else
					mach.type = 0
				end
			end
			if (P_IsObjectOnGround(player.mo)
			or (player.mo.eflags & MFE_JUSTHITFLOOR))
				if mach.type < 3
					P_Thrust(player.mo, player.drawangle, FRACUNIT/2)
				elseif mach.type == 3
					P_Thrust(player.mo, player.drawangle, FRACUNIT/10)
				elseif mach.type == 4
					P_Thrust(player.mo, player.drawangle, FRACUNIT/10)
				end
			end
			if mach.type == 1
			and not S_SoundPlaying(player.mo, sfx_mch1)
			and P_IsObjectOnGround(player.mo)
				S_StartSound(player.mo, sfx_mch1)
			elseif mach.type ~= 1
			or not P_IsObjectOnGround(player.mo)
				S_StopSoundByID(player.mo, sfx_mch1)
			end
			if mach.type == 2
			and not S_SoundPlaying(player.mo, sfx_mch2)
			and P_IsObjectOnGround(player.mo)
				S_StartSound(player.mo, sfx_mch2)
			elseif mach.type ~= 2
			or not P_IsObjectOnGround(player.mo)
				S_StopSoundByID(player.mo, sfx_mch2)
			end
			if mach.type == 3
			and not S_SoundPlaying(player.mo, sfx_mch3)
				S_StartSound(player.mo, sfx_mch3)
			elseif mach.type ~= 3
				S_StopSoundByID(player.mo, sfx_mch3)
			end
			if mach.type == 4
			and not S_SoundPlaying(player.mo, sfx_mch4)
				S_StartSound(player.mo, sfx_mch4)
			elseif mach.type ~= 4
				S_StopSoundByID(player.mo, sfx_mch4)
			end
			if mach.type > 2
				player.charflags = $|SF_RUNONWATER
			else
				player.charflags = $1 & ~SF_RUNONWATER
			end
			if leveltime%2 == 0
				local mobj = P_SpawnGhostMobj(player.mo)
				mobj.colorized = true
				mobj.frame = TR_TRANS10|player.mo.frame|FF_FULLBRIGHT
				mobj.fuse = 999
				mobj.tics = 5
				if leveltime%4 ~= 0
					mobj.color = SKINCOLOR_GREEN
				else
					mobj.color = SKINCOLOR_RED
				end
			end
			if mach.type == 4 and pb.effects.cooleffect <= 0
				local x,y = cos(player.drawangle),sin(player.drawangle)
				local runmacheffect = P_SpawnMobjFromMobj(player.mo,-30*x,-30*y,0,MT_MACHE)
				runmacheffect.angle = (R_PointToAngle2(runmacheffect.x, runmacheffect.y, player.mo.x, player.mo.y) + ANGLE_90)
				pb.effects.cooleffect = 10
			end
			if mach.type > 2 and not ((player.mo.eflags & MFE_UNDERWATER) or player.powers[pw_spacetime]) and pb.effects.wind >= FRACUNIT
				local x,y = cos(player.drawangle),sin(player.drawangle)
				local wind = P_SpawnMobjFromMobj(player.mo,P_RandomRange(0, -500)*x,P_RandomRange(0, -500)*y,P_RandomRange(0, 150)*FRACUNIT,MT_SPDLINES)
				wind.angle = R_PointToAngle2(wind.x, wind.y, player.mo.x, player.mo.y)
				wind.state = S_SPEED_LINES
				pb.effects.wind = 0*FRACUNIT
			end
			if P_IsObjectOnGround(player.mo)
			and mach.type > 2
			and leveltime%10 == 0
				for i = -1, 1, 2
					local ang = i * ANG10
					local factor = FixedMul(4*player.mo.scale, cos(ang))
					local x = P_ReturnThrustX(player.mo, player.drawangle + ANGLE_180 + ang, 24*player.mo.scale)
					local y = P_ReturnThrustY(player.mo, player.drawangle + ANGLE_180 + ang, 24*player.mo.scale)
					local dust = P_SpawnMobjFromMobj(player.mo, x, y, 0, MT_MACH3D)
					if mach.type == 3
						dust.scale = 2*$/3
					else
						dust.scale = 2*$/2
					end
					dust.angle = R_PointToAngle2(dust.x, dust.y, player.mo.x, player.mo.y)
					dust.state = S_MACH3_DASH
					dust.momx = FixedMul(factor, cos(dust.angle - i*ANGLE_90))
					dust.momy = FixedMul(factor, sin(dust.angle - i*ANGLE_90))
				end
			end
		else
			if not pb.moveset.wallrun.active
				S_StopSoundByID(player.mo, sfx_mch4)
				S_StopSoundByID(player.mo, sfx_mch3)
				S_StopSoundByID(player.mo, sfx_mch2)
				S_StopSoundByID(player.mo, sfx_mch1)
			end
			mach.type = 0
		end
		if pb.effects.cooleffect > 0
			pb.effects.cooleffect = $ - 1
		end
		if mach.type > 2 
		or pb.moveset.slide.active
		or pb.moveset.superjump.active
		or pb.moveset.wallrun.active
			if not pb.moveset.superjump.active
			and not pb.moveset.wallrun.active
				pb.effects.wind = $ + FixedDiv(player.speed, 80*FRACUNIT)
			else
				pb.effects.wind = $ + FixedDiv(player.mo.momz, 30*FRACUNIT)
			end
		else
			pb.effects.wind = 0*FRACUNIT
		end
	end
end)

addHook("PlayerCanDamage", function(player)
	if player.pizzablast.moveset.mach.active
	or player.speed > 25*FRACUNIT
	and not player.pizzablast.moveset.mach.active
		return true
	end
end)