addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and player.pizzablast
	and player.pizzablast.other.pbparts ~= 1
	and player.pizzablast.other.pbparts ~= 3
		local pb = player.pizzablast
		local superjump = pb.moveset.superjump
		local buttons = pb.moveset.buttons
		if buttons.c2 == 1
		and P_IsObjectOnGround(player.mo)
		and pb.moveset.mach.type > 2
		and not pb.moveset.grab.active
		and not pb.moveset.slide.active
		and player.playerstate == PST_LIVE
		and not player.powers[pw_carry]
		and not pb.moveset.taunt.active
		and not pb.moveset.taunt.timer
		and not pb.moveset.bash.active
		and not pb.moveset.bodyslam.active
		and not pb.moveset.divebomb.active
		and not pb.moveset.divebomb.cactive
		and not pb.moveset.bodyslam.cactive
		and not pb.moveset.redirect.active
		and not pb.moveset.wallrun.active
			superjump.build.active = true
			S_StartSound(player.mo, sfx_sjs)
		end
		if superjump.build.active
			if player.mo.state == S_PLAY_PAIN
			or P_PlayerInPain(player)
			or player.playerstate ~= PST_LIVE
			or player.powers[pw_carry]
				superjump.build.active = false
				return
			end
			player.mo.state = S_PLAY_SPINDASH
			player.pflags = $|PF_JUMPSTASIS
			if not S_SoundPlaying(player.mo, sfx_sjs)
			and not S_SoundPlaying(player.mo, sfx_sjh)
				S_StartSound(player.mo, sfx_sjh)
			end
			if player.speed >= 5*FRACUNIT
				P_InstaThrust(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), player.speed - (player.speed - 5*FRACUNIT))
			end
			if not buttons.c2
				superjump.build.active = false
				superjump.active = true
				superjump.timer = 60
				superjump.angle = player.drawangle
				S_StopSoundByID(player.mo, sfx_sjs)
				S_StopSoundByID(player.mo, sfx_sjh)
				S_StartSound(player.mo, sfx_sjr)
			end
		end
		if superjump.timer > 0
			if player.mo.state == S_PLAY_PAIN
			or P_PlayerInPain(player)
			or player.playerstate ~= PST_LIVE
				superjump.timer = 0
				return
			end
			player.powers[pw_strong] = $|STR_CEILING|STR_SPIKE
			superjump.timer = $ - 1
			superjump.active = true
			P_SetObjectMomZ(player.mo, superjump.timer*FRACUNIT, false)
			player.mo.state = S_PLAY_SPRING
			P_InstaThrust(player.mo, player.mo.angle, 0*FRACUNIT)
			player.drawangle = superjump.angle
			superjump.angle = $ + ANGLE_22h
			if pb.effects.wind >= FRACUNIT
				local x,y = cos(player.drawangle),sin(player.drawangle)
				local wind = P_SpawnMobjFromMobj(player.mo,P_RandomRange(-150, 150)*x,P_RandomRange(-150, 150)*y,P_RandomRange(-500, 500)*FRACUNIT,MT_SPDLINES)
				wind.angle = R_PointToAngle2(wind.x, wind.y, player.mo.x, player.mo.y) + ANGLE_90
				wind.state = S_WALL_LINES
				pb.effects.wind = 0*FRACUNIT
			end
			if (player.mo.z + player.mo.height == player.mo.ceilingz or (player.mo.flags2 & MF2_OBJECTFLIP) and player.mo.z + player.mo.height == player.mo.floorz)
				superjump.timer = 0
				superjump.active = false
				superjump.ctimer = 30
				superjump.cactive = true
				S_StartSound(player.mo, sfx_cbonk)
				player.mo.spriteyscale = (FU/3)
				player.mo.spritexscale = (player.mo.spriteyscale*8)
			end
			if leveltime%2 == 0
				local mobj = P_SpawnGhostMobj(player.mo)
				mobj.colorized = true
				mobj.frame = TR_TRANS10|player.mo.frame|FF_FULLBRIGHT
				mobj.fuse = 999
				mobj.tics = 5
				if leveltime%4 ~= 0
					mobj.color = SKINCOLOR_GREEN
				else
					mobj.color = SKINCOLOR_RED
				end
			end
		elseif superjump.timer <= 0
		and superjump.active
			if not (player.mo.state == S_PLAY_PAIN
			or P_PlayerInPain(player)
			or player.playerstate ~= PST_LIVE)
				player.mo.state = S_PLAY_PAIN
			end
			player.powers[pw_strong] = $ & ~(STR_CEILING|STR_SPIKE)
			superjump.active = false
		end
		if superjump.ctimer
			if player.mo.state == S_PLAY_PAIN
			or P_PlayerInPain(player)
			or player.playerstate ~= PST_LIVE
				superjump.ctimer = 0
				return
			end
			superjump.cactive = true
			superjump.ctimer = $ - 1
			P_SetObjectMomZ(player.mo, 100*FRACUNIT, false)
			P_InstaThrust(player.mo, player.mo.angle, 0*FRACUNIT)
			player.mo.state = S_PLAY_DEAD
		elseif superjump.ctimer <= 0
		and superjump.cactive == true
			if not (player.mo.state == S_PLAY_PAIN
			or P_PlayerInPain(player)
			or player.playerstate ~= PST_LIVE)
				P_SetObjectMomZ(player.mo, 100*FRACUNIT, false)
				P_InstaThrust(player.mo, player.mo.angle, 0*FRACUNIT)
				player.mo.state = S_PLAY_PAIN
			end
			player.mo.spriteyscale = FRACUNIT
			player.mo.spritexscale = FRACUNIT
			superjump.cactive = false
		end
	end
end)