// Sponsored Segment for TGTLS!
addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and player.pizzablast
	and player.pizzablast.other.pbparts ~= 1
	and player.pizzablast.other.pbparts ~= 3
		local pb = player.pizzablast
		local taunt = pb.moveset.taunt
		local buttons = pb.moveset.buttons
		if not buttons.tf
		and not taunt.active
			taunt.prevmomx = player.mo.momx
			taunt.prevmomy = player.mo.momy
			taunt.prevmomz = player.mo.momz
			taunt.prevstate = player.mo.state
			taunt.prevspeed = player.normalspeed
		end
	end
end)

addHook("PostThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.valid
		and player.pizzablast
			local pb = player.pizzablast
			local taunt = pb.moveset.taunt
			local buttons = pb.moveset.buttons
			if buttons.tf == 1
			and not taunt.active
			and not player.powers[pw_carry]
			and player.playerstate == PST_LIVE
			and not P_PlayerInPain(player)
			and player.mo.state ~= S_PLAY_PAIN
			and not player.powers[pw_nocontrol]
			and not pb.moveset.grab.active
			and not pb.moveset.grab.holding
			and not pb.moveset.slide.active
			and not pb.moveset.superjump.active
			and not pb.moveset.superjump.build.active
			and not pb.moveset.superjump.cactive
			and not pb.moveset.taunt.active
			and not pb.moveset.taunt.timer
			and not pb.moveset.roll.active
			and not pb.moveset.bash.active
			and not pb.moveset.dive.active
			and not pb.moveset.bodyslam.active
			and not pb.moveset.divebomb.active
			and not pb.moveset.divebomb.cactive
			and not pb.moveset.bodyslam.cactive
				S_StartSound(player.mo, sfx_taunt)
				taunt.active = true
			end
			if taunt.active
				player.mo.momx = 0
				taunt.bubble = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_TAUNT)
				taunt.bubble.scale = player.mo.scale+FRACUNIT/6
				player.mo.momy = 0
				player.mo.momz = 0
				player.pflags = $|PF_JUMPSTASIS
				taunt.timer = $1+1
				if taunt.posed
				and player.mo.state ~= taunt.pose
					player.mo.state = taunt.pose
				end
				if (player.mo.eflags & MFE_VERTICALFLIP)
					taunt.bubble.eflags = $|MFE_VERTICALFLIP
				end
				if PBPizzaTime.active
				and not taunt.posed
					player.score = $ + 150
				end
			end
			if taunt.timer == 16
				taunt.active = false
				taunt.timer = 0
				taunt.bubble = nil
				player.mo.momx = taunt.prevmomx
				player.mo.momy = taunt.prevmomy
				player.pflags = $ & ~PF_JUMPSTASIS
				player.mo.momz = taunt.prevmomz
				player.mo.state = taunt.prevstate
				taunt.posed = false
				if buttons.tf and player.speed == 0*FRACUNIT
					taunt.breakdance = true
				end
			end
		end
	end
end)

//made by clairbun
rawset(_G, "L_Choose", function(...)
	local args = {...}
	local choice = P_RandomRange(1,#args)
	return args[choice]
end)

addHook("PostThinkFrame", function()
if NoMoveset return end
	for player in players.iterate()
		if player.mo and player.mo.valid
		and player.pizzablast
			local pb = player.pizzablast
			local taunt = pb.moveset.taunt
			local buttons = pb.moveset.buttons
			if taunt.active
			and not taunt.posed
				player.mo.state = L_Choose(S_PLAY_ROLL,S_PLAY_SPRING,S_PLAY_PAIN,S_PLAY_DEAD,S_PLAY_RUN,S_PLAY_WAIT,S_PLAY_SUPER_TRANS1,S_PLAY_EDGE,S_PLAY_STND,S_PLAY_SPINDASH,S_PLAY_DASH)
				taunt.posed = true
				taunt.pose = player.mo.state
			end
		end
	end
end)

// A little bit of code from another project

addHook("ShouldDamage", function(target, inflictor)
	if target and target.valid
	and inflictor and inflictor.valid
	and target.player and target.player.valid
	and target.player.pizzablast
	//and (inflictor.flags & MF_MISSILE)
	and target.player.pizzablast.moveset.taunt.active
		local player = target.player
		local pb = player.pizzablast
		local taunt = pb.moveset.taunt
		local buttons = pb.moveset.buttons
		player.powers[pw_flashing] = 1*TICRATE
		if inflictor.type == MT_PIZZAFACE
			player.powers[pw_invulnerability] = 1*TICRATE
			inflictor.state = S_PIZZAFACERECOVER
		else
			if (inflictor.flags & MF_ENEMY)
				table.insert(player.pizzablast.moveset.grab.hit, inflictor)
				inflictor.true_sprite = inflictor.sprite
				inflictor.true_flags = inflictor.flags
				inflictor.flags = $ & ~(MF_NOGRAVITY | MF_FLOAT | MF_NOCLIPHEIGHT | MF_NOCLIPTHING)
				inflictor.state = S_KNOCKED
			end
		end
		P_InstaThrust(target, R_PointToAngle2(0, 0, inflictor.momx, inflictor.momy), -7*FRACUNIT)
		inflictor.angle = R_PointToAngle2(0, 0, inflictor.momx, inflictor.momy)
		inflictor.momx = -$
		inflictor.momy = -$
		inflictor.momz = -$
		if (inflictor.flags & MF_MISSILE)
			inflictor.target = target
		end
		taunt.active = false
		taunt.timer = 0
		S_StartSound(target, sfx_poww)
		target.state = L_Choose(S_PLAY_SUPER_TRANS1, S_PLAY_ROLL, S_PLAY_STND)
		if inflictor.type ~= MT_PIZZAFACE
			if player.mo.state == S_PLAY_SUPER_TRANS1
				player.powers[pw_flashing] = $ + 1*TICRATE
			end
		else
			player.powers[pw_invulnerability] = $ + 1*TICRATE
		end
		return false
	end
end)

addHook("ShouldDamage", function(target, inflictor, source, damage, damagetype)
    if target and target.valid
	and inflictor and inflictor.valid
	and source and source.valid
	and target.player and target.player.valid
	and target.player.pizzablast
	and target.player.pizzablast.moveset.taunt.active
	and not (inflictor.flags & MF_MISSILE)
	and (damagetype ~= DMG_DEATHMASK)
		local player = target.player
		local pb = player.pizzablast
		local taunt = pb.moveset.taunt
		local buttons = pb.moveset.buttons
		target.player.powers[pw_flashing] = 1*TICRATE
		P_DamageMobj(source, target, target)
		taunt.active = false
		taunt.timer = 0
		S_StartSound(target, sfx_poww)
		P_InstaThrust(target, R_PointToAngle2(0, 0, inflictor.momx, inflictor.momy), -7*FRACUNIT)
		target.state = L_Choose(S_PLAY_SUPER_TRANS1, S_PLAY_ROLL, S_PLAY_STND)
		if inflictor.type == MT_PIZZAFACE
			target.player.powers[pw_invulnerability] = 1*TICRATE
			inflictor.state = S_PIZZAFACERECOVER
		end
        return false
    end
end, MT_PLAYER)