addHook("MobjMoveBlocked", function(mo, mobj, line)
	if mobj and mobj.valid return end
	if mo and mo.valid
	and line and line.valid
	and mo.player
		local player = mo.player
		if player.mo and player.mo.valid
		and player.pizzablast
		and player.pizzablast.other.pbparts ~= 1
		and player.pizzablast.other.pbparts ~= 3
			local wallrun = player.pizzablast.moveset.wallrun
			local buttons = player.pizzablast.moveset.buttons
			local pb = player.pizzablast
			if (pb.moveset.mach.active
			or pb.moveset.grab.active
			or buttons.c1)
			and (not P_IsObjectOnGround(player.mo)
			or (player.mo.standingslope
			and player.mo.z > wallrun.prevz))
			and player.powers[pw_pushing]
			and not pb.moveset.grab.holding
			and not pb.moveset.slide.active
			and not pb.moveset.superjump.active
			and not pb.moveset.superjump.build.active
			and not pb.moveset.superjump.cactive
			and not pb.moveset.taunt.active
			and not pb.moveset.taunt.timer
			and not pb.moveset.roll.active
			and not pb.moveset.bash.active
			and not pb.moveset.dive.active
			and not pb.moveset.bodyslam.active
			and not pb.moveset.divebomb.active
			and not pb.moveset.divebomb.cactive
			and not pb.moveset.bodyslam.cactive
			and not pb.moveset.redirect.active
			and not pb.moveset.wallrun.active
			and not P_PlayerInPain(player)
			and player.mo.state ~= S_PLAY_PAIN
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
				if wallrun.speed < 20*FRACUNIT
					if pb.moveset.mach.type == 1
						wallrun.speed = 20*FRACUNIT
					elseif pb.moveset.mach.type == 2
						wallrun.speed = 30*FRACUNIT
					elseif pb.moveset.mach.type == 3
						wallrun.speed = 40*FRACUNIT
					elseif pb.moveset.mach.type == 4
						wallrun.speed = 60*FRACUNIT
					end
				end
				wallrun.speed = $ + player.mo.momz*2
				pb.moveset.grab.active = false
				pb.moveset.grab.timer = 0
				wallrun.active = true
			end
		end
	end
end, MT_PLAYER)


addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
	and player.pizzablast
	and player.pizzablast.other.pbparts ~= 1
	and player.pizzablast.other.pbparts ~= 3
		local wallrun = player.pizzablast.moveset.wallrun
		local buttons = player.pizzablast.moveset.buttons
		local pb = player.pizzablast
		if wallrun.active
			if player.mo.state == S_PLAY_PAIN
			or P_PlayerInPain(player)
			or player.playerstate ~= PST_LIVE
			or player.powers[pw_carry]
				wallrun.active = false
				return
			end
			if not player.powers[pw_pushing]
				P_InstaThrust(player.mo, player.mo.angle, wallrun.speed)
				P_SetObjectMomZ(player.mo, 0*FRACUNIT, false)
				player.mo.state = S_PLAY_ROLL
				wallrun.active = false
				return
			end
			if not pb.moveset.mach.active
				P_InstaThrust(player.mo, player.mo.angle, -5*FRACUNIT)
				P_SetObjectMomZ(player.mo, 0*FRACUNIT, false)
				player.mo.state = S_PLAY_FALL
				wallrun.active = false
				return
			end
			if buttons.jump == 1
				P_InstaThrust(player.mo, player.mo.angle, -10*FRACUNIT)
				P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
				player.mo.angle = R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)
				player.drawangle = player.mo.angle
				player.mo.state = S_PLAY_JUMP
				wallrun.active = false
				return
			end
			P_SetObjectMomZ(player.mo, wallrun.speed/2, false)
			P_InstaThrust(player.mo, player.mo.angle, 10*FRACUNIT)
			player.mo.state = S_PLAY_SPRING
			player.pflags = $ & ~PF_JUMPED
			if pb.effects.wind >= FRACUNIT
				local x,y = cos(player.drawangle),sin(player.drawangle)
				local wind = P_SpawnMobjFromMobj(player.mo,P_RandomRange(-150, 150)*x,P_RandomRange(-150, 150)*y,P_RandomRange(-500, 500)*FRACUNIT,MT_SPDLINES)
				wind.angle = R_PointToAngle2(wind.x, wind.y, player.mo.x, player.mo.y) + ANGLE_90
				wind.state = S_WALL_LINES
				pb.effects.wind = 0*FRACUNIT
			end
			if wallrun.speed < 40*FRACUNIT
				wallrun.speed = $ + FRACUNIT
			elseif wallrun.speed >= 40*FRACUNIT
			and wallrun.speed < 80*FRACUNIT
				wallrun.speed = $ + FRACUNIT/5
			end
			if (player.mo.z + player.mo.height == player.mo.ceilingz or (player.mo.flags2 & MF2_OBJECTFLIP) and player.mo.z + player.mo.height == player.mo.floorz)
				wallrun.active = false
				pb.moveset.superjump.ctimer = 30
				pb.moveset.superjump.cactive = true
				S_StartSound(player.mo, sfx_cbonk)
				player.mo.spriteyscale = (FU/3)
				player.mo.spritexscale = (player.mo.spriteyscale*8)
			end
		else
			if not player.powers[pw_pushing]
				wallrun.speed = player.speed
			end
		end
		if leveltime%2 == 0
			wallrun.prevz = player.mo.z
		end
	end
end)