rawset(_G, "PizzaBlastStartupTable", function(player)
	player.pizzablast = {
		combo = {
			timer = 0,
			amount = 0,
			canp = true,
			congrats = true,
			active = false,
			isp = false
		},
		moveset = {
			buttons = {
				jump = 0,
				spin = 0,
				c1 = 0,
				c2 = 0,
				c3 = 0,
				fire = 0,
				firen = 0,
				tf = 0
			},
			mach = {
				type = 0,
				active = false
			},
			grab = {
				active = false,
				timer = 0,
				mobj = player.mo,
				holding = false,
				hit = {},
				angle = ANG1,
			},
			slide = {
				active = false,
				timer = 0,
				angle = ANG1
			},
			superjump = {
				build = {
					active = false
				},
				active = false,
				timer = 0,
				angle = 0,
				ctimer = 0,
				cactive = false
			},
			bash = {
				active = false,
				timer = 0,
				type = 0
			},
			roll = {
				active = false,
				timer = 0
			},
			dive = {
				active = false,
				speed = 0
			},
			bodyslam = {
				active = false,
				timer = 0,
				momz = 0,
				cactive = false
			},
			divebomb = {
				active = false,
				timer = 0,
				momz = 0,
				cactive = false
			},
			redirect = {
				active = false,
				timer = 0,
				water = 0
			},
			wallrun = {
				active = false,
				speed = 0,
				prevz = 0,
				timer = 0,
				cactive = false
			},
			taunt = {
				active = false,
				timer = 0,
				bubble = player.mo,
				posed = false,
				pose = S_PLAY_RUN,
				breakdance = false,
				prevmomx = 0,
				prevmomy = 0,
				prevmomz = 0,
				prevstate = S_NULL,
				prevspeed = 0
			}
		},
		effects = {
			wind = 0,
			cooleffect = 0
		},
		other = {
			hardmode = false,
			pbparts = 0,
			ptportal = 0,
			Lap2Active = false
		}
	}
	
	CONS_Printf(player, "Pizza Blast! The only mod where the title lies!")
	CONS_Printf(player, "Mod made by \x8EKirby\x80, the person who'll never make a Kirby mod")
end)

rawset(_G, "PBPizzaTime", {
	active = false,
	timer = 77*FRACUNIT,
	john = nil,
	MaxTime = 0,
	TimeTilPF = 0,
	exit = nil,
	portalspawned = false,
	pizzaboi = {
		pizzaface = nil,
		spawned = false,
		flyspeed = 0
	},
	Lap2 = {
		x = 0,
		y = 0,
		z = 0
	},
	leveltimes = {
		["Greenflower Zone 1"] = 70*TICRATE,
		["Green Grove Zone 2"] = 95*TICRATE,
		["Square Valley Zone 3"] = 1*TICRATE,
		["Techno Hill Zone 1"] = 105*TICRATE,
		["TechnoVade Zone 2"] = 150*TICRATE,
		["Techno Gone Wrong Zone 3"] = 1*TICRATE,
		["Deep Sea Zone 1"] = 85*TICRATE,
		["Deep Dive 8 Zone 2"] = 190*TICRATE,
		["Too Deep In Zone 3"] = 1*TICRATE,
		["Castle Eggman Zone 1"] = 95*TICRATE,
		["Fortress Eggman Zone 2"] = 120*TICRATE,
		["Colosseum Eggman Zone 3"] = 1*TICRATE,
		["Arid Canyon Zone 1"] = 95*TICRATE,
		["Arid Ride Zone 2"] = 180*TICRATE,
		["It's Nerf or Nothin Zone 3"] = 1*TICRATE,
		["Bloodsauce Volcano Zone 1"] = 300*TICRATE,
		["Egg Rock Zone 1"] = 300*TICRATE,
		["Eggman Land Zone 2"] = 5*TICRATE,
		["Stardust Replay Zone 1"] = 1*TICRATE,
		["Made of Metal Zone 2"] = 1*TICRATE,
		["Final Stretch Zone 1"] = 1*TICRATE,
		["Big Rock Acts Kindly Zone 3"] = 1*TICRATE
	},
	portalspawns = {
		["Greenflower Zone 1"] = {x = 528, y = 688, z = 32, angle = ANGLE_45},
		["Green Grove Zone 2"] = {x = -1248, y = 6496, z = -64, angle = 0},
		["Techno Hill Zone 1"] = {x = 2784, y = 3584, z = 1248, angle = 0},
		["TechnoVade Zone 2"] = {x = -14336, y = 832, z = 1944, angle = ANGLE_180},
		["Deep Sea Zone 1"] = {x = 0, y = 1014, z = 160, angle = ANGLE_270},
		["Deep Dive 8 Zone 2"] = {x = 18304, y = -16928, z = 1024, angle = ANGLE_180}
		/*["Castle Eggman Zone 1"] = 95*TICRATE,
		["Fortress Eggman Zone 2"] = 120*TICRATE,
		["Arid Canyon Zone 1"] = 95*TICRATE,
		["Arid Ride Zone 2"] = 180*TICRATE,
		["Bloodsauce Volcano Zone 1"] = 300*TICRATE,
		["Egg Rock Zone 1"] = 300*TICRATE,
		["Eggman Land Zone 2"] = 5*TICRATE*/
	}
})

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if not player.pizzablast then PizzaBlastStartupTable(player) return end
		local pb = player.pizzablast
		player.normalspeed = 20*FRACUNIT
		player.charflags = $|SF_NOSHIELDABILITY
		if not pb.other.hardmode
		and not multiplayer
			player.lives = INFLIVES
		end
		if pb.moveset.mach.active
		or pb.moveset.roll.active
			player.mo.friction = FRACUNIT
			player.charflags = $ & ~SF_NOSKID
			/*if player.powers[pw_sneakers]
			and player.mo.state ~= S_PLAY_SKID
				P_Thrust(player.mo, player.drawangle, FRACUNIT/2)
			end*/
		else
			player.mo.friction = 29*FRACUNIT/32
			player.charflags = $ & ~SF_NOSKID
		end
		if player.speed >= 80*FRACUNIT
		and not player.powers[pw_sneakers]
			P_InstaThrust(player.mo, R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy), player.speed - (player.speed - 80*FRACUNIT))
		end
		if (pb.other.hardmode
		or multiplayer)
		and player.playerstate == PST_LIVE
			player.lives = 1
			player.continues = 0
		end
		if pb.other.pbparts ~= 1
		and pb.other.pbparts ~= 3
			if (player.charability2 ~= CA2_NONE)
				player.charability2 = CA2_NONE
			end
			if (player.charability ~= CA_NONE)
				player.charability = CA_NONE
			end
		else
			player.charability2 = skins[player.mo.skin].ability2
			player.charability = skins[player.mo.skin].ability
		end
		if not player.exitting
			if (player.cmd.buttons & BT_JUMP)
				pb.moveset.buttons.jump = $ + 1
			else
				pb.moveset.buttons.jump = 0
			end
			if (player.cmd.buttons & BT_SPIN)
				pb.moveset.buttons.spin = $ + 1
			else
				pb.moveset.buttons.spin = 0
			end
			if (player.cmd.buttons & BT_CUSTOM1)
				pb.moveset.buttons.c1 = $ + 1
			else
				pb.moveset.buttons.c1 = 0
			end
			if (player.cmd.buttons & BT_CUSTOM2)
				pb.moveset.buttons.c2 = $ + 1
			else
				pb.moveset.buttons.c2 = 0
			end
			if (player.cmd.buttons & BT_CUSTOM3)
				pb.moveset.buttons.c3 = $ + 1
			else
				pb.moveset.buttons.c3 = 0
			end
			if (player.cmd.buttons & BT_FIRENORMAL)
				pb.moveset.buttons.firen = $ + 1
			else
				pb.moveset.buttons.firen = 0
			end
			if (player.cmd.buttons & BT_ATTACK)
				pb.moveset.buttons.fire = $ + 1
			else
				pb.moveset.buttons.fire = 0
			end
			if (player.cmd.buttons & BT_TOSSFLAG)
				pb.moveset.buttons.tf = $ + 1
			else
				pb.moveset.buttons.tf = 0
			end
		end
	end
end)

addHook("PlayerSpawn", function(player)
	if player.mo and player.mo.valid
	and player.pizzablast
		local pb = player.pizzablast
		player.score = 0
		pb.combo.timer = 0
		pb.combo.amount = 0
		pb.combo.canp = true
		pb.combo.active = false
		pb.combo.congrats = true
		pb.combo.isp = false
		pb.moveset.mach.type = 0
		pb.moveset.mach.active = false
		pb.moveset.grab.active = false
		pb.moveset.grab.timer = 0
		pb.moveset.grab.mobj = nil
		pb.moveset.grab.holding = false
		pb.moveset.grab.hit = {}
		pb.moveset.slide.active = false
		pb.moveset.slide.timer = 0
		pb.moveset.slide.angle = player.drawangle
		pb.moveset.superjump.active = false
		pb.moveset.superjump.timer = 0
		pb.moveset.superjump.cactive = false
		pb.moveset.superjump.ctimer = 0
		pb.moveset.superjump.angle = player.drawangle
		pb.moveset.superjump.build.active = false
		pb.moveset.taunt.active = false
		pb.moveset.taunt.timer = 0
		pb.moveset.taunt.bubble = nil
		pb.moveset.taunt.posed = false
		pb.moveset.taunt.pose = S_PLAY_RUN
		pb.moveset.taunt.breakdance = false
		pb.moveset.bash.active = false
		pb.moveset.bash.timer = 0
		pb.moveset.roll.active = false
		pb.moveset.roll.timer = 0
		pb.moveset.dive.active = false
		pb.moveset.dive.speed = 0
		pb.moveset.bodyslam.active = false
		pb.moveset.bodyslam.momz = 0
		pb.moveset.bodyslam.timer = 0
		pb.moveset.bodyslam.cactive = false
		pb.moveset.divebomb.active = false
		pb.moveset.divebomb.momz = 0
		pb.moveset.divebomb.timer = 0
		pb.moveset.divebomb.cactive = false
		pb.moveset.redirect.active = false
		pb.moveset.redirect.timer = 0
		pb.moveset.redirect.type = 0
		pb.moveset.redirect.water = false
		pb.moveset.wallrun.active = false
		pb.moveset.wallrun.speed = 0
		pb.moveset.wallrun.prevz = player.mo.z
		pb.moveset.wallrun.timer = 0
		pb.moveset.wallrun.cactive = false
		pb.other.ptportal = 0
		pb.other.Lap2Active = false
		if pb.other.hardmode
			pb.combo.timer = 300
			player.score = 35000
		end
	end
end)

addHook("MapChange", function()
	PBPizzaTime.active = false
	PBPizzaTime.timer = 77*FRACUNIT
	PBPizzaTime.john = nil
	PBPizzaTime.MaxTime = 0
	PBPizzaTime.TimeTilPF = 0
	PBPizzaTime.exit = nil
	PBPizzaTime.portalspawned = false
	PBPizzaTime.pizzaboi.pizzaface = nil
	PBPizzaTime.pizzaboi.spawned = false
	PBPizzaTime.pizzaboi.flyspeed = 0
	PBPizzaTime.Lap2.x = 0
	PBPizzaTime.Lap2.y = 0
	PBPizzaTime.Lap2.z = 0
	PBPizzaTime.Lap2.active = false
end)